class
	AST_TYPEDEF_DECLARATION

inherit
	AST_DECLARATION
		redefine
			make_copy
		end
	AST_UTILITIES

create
	make_from_antlr,
	make_copy

feature {NONE}

	make_from_antlr (node: ANTLR_AST_NODE; a_parent: AST_NODE; a_source_info: SOURCE_INFO)
		require
			node /= Void and then node.type = C_kw_typedef
			a_source_info /= Void
		local
			vd: AST_VARIABLE_DECLARATION
			fd: AST_FUNCTION_DECLARATION
		do
			parent := a_parent
			inspect
				node.children.first.type
			when Ast_variable_declaration_or_type then
				vd := create {AST_VARIABLE_DECLARATION}.make_from_antlr (node.children.first, Void, Void)
				identifier := vd.identifier
				type := vd.type.ast_twin
			when Ast_function_declaration then
				fd := create {AST_FUNCTION_DECLARATION}.make_from_antlr (node.children.first, Void, Void)
				identifier := fd.identifier
				type := create {AST_FUNCTION_TYPE}.make (fd.return_type.ast_twin, fd.parameter_list.ast_twin)
			end
			type.parent := Current
			source_info := a_source_info
		end

feature {ANY}

	type: AST_TYPE

feature {ANY} -- AST_NODE

	accept (v: AST_VISITOR)
		local
			visit_children: BOOLEAN
		do
			v.pre_visit (Current)
			visit_children := v.visit_typedef_declaration (Current)
			if visit_children then
				visit_node (type, v)
			end
			v.end_visit_typedef_declaration (Current)
			v.post_visit (Current)
		end

	ast_twin: like Current
		do
			create Result.make_copy (Current)
		end

	make_copy (a_other: like Current)
		do
			Precursor (a_other)
			type := a_other.type.ast_twin
			type.parent := Current
		end

invariant
	type /= Void

end
