class
	AST_ALIGNOF_CALL

inherit
	AST_EXPRESSION

create
	make_from_antlr,
	make_copy

feature {NONE}

	make_from_antlr (node: ANTLR_AST_NODE; init_parent: AST_NODE)
		require
			node /= Void and then node.type = Ast_alignof_call
		do
			parent := init_parent
			type := process_type (node.children.first, Current)
		end

feature {ANY}

	type: AST_TYPE

	type_binding: AST_TYPE
		once ("OBJECT")
			Result := create {AST_BASIC_TYPE}.make (Ast_bt_unsigned_int)
		end

feature {ANY} -- AST_NODE

	accept (v: AST_VISITOR)
		local
			visit_children: BOOLEAN
		do
			v.pre_visit (Current)
			visit_children := v.visit_alignof_call (Current)
			if visit_children then
				visit_node (type, v)
			end
			v.end_visit_alignof_call (Current)
			v.post_visit (Current)
		end

	ast_twin: like Current
		do
			create Result.make_copy (Current)
		end

	make_copy (other: like Current)
		do
			type := other.type.ast_twin
			type.parent := Current
		end

invariant
	type /= Void

end
