class
	AST_BASIC_TYPE

inherit
	AST_TYPE
		redefine
			make_copy
		end

create
	make,
	make_from_antlr,
	make_copy

feature {NONE}

	make (a_type: INTEGER)
		do
			type := a_type
		end

	make_from_antlr (node: ANTLR_AST_NODE; init_parent: AST_NODE)
		require
			node /= Void and then node.type = Ast_basic_type
		do
			parent := init_parent
			make (node.children.first.type)
		end

feature {ANY}

	type: INTEGER

feature {ANY} -- AST_NODE

	accept (v: AST_VISITOR)
		local
			visit_children: BOOLEAN
		do
			v.pre_visit (Current)
			visit_children := v.visit_basic_type (Current)
			if visit_children then
				-- no children
			end
			v.end_visit_basic_type (Current)
			v.post_visit (Current)
		end

	ast_twin: like Current
		do
			create Result.make_copy (Current)
		end

	make_copy (other: like Current)
		do
			Precursor (other)
			type := other.type
		end

feature {ANY} -- AST_TYPE

	is_equal_type (a_type: AST_TYPE): BOOLEAN
		local
			l_bf1, l_bf2: AST_BITFIELD
		do
			if attached {AST_BASIC_TYPE} a_type as other_type then
				Result := type = other_type.type

				if Result then
					l_bf1 ?= parent
					l_bf2 ?= a_type.parent
					if l_bf1 = Void and l_bf2 = Void then
						-- ok
					elseif l_bf1 = Void or l_bf2 = Void then
						Result := False
					else
						Result := l_bf1.size.value.is_equal (l_bf2.size.value)
					end
				end
			end
		end

invariant
	type = Ast_bt_void or type = Ast_bt_bool or
	type = Ast_bt_char or type = Ast_bt_short or type = Ast_bt_int or type = Ast_bt_long or type = Ast_bt_long_long or
	type = Ast_bt_unsigned_char or type = Ast_bt_unsigned_short or type = Ast_bt_unsigned_int or type = Ast_bt_unsigned_long or type = Ast_bt_unsigned_long_long or
	type = Ast_bt_float or type = Ast_bt_double or type = Ast_bt_long_double or
	type = Ast_bt_builtin_va_list

end
