class
	CFG_BASIC_BLOCK

inherit
	DEFAULT_HASHABLE
		redefine
			default_create
		end

feature {NONE}

	default_create
		do
			nodes := create {TWO_WAY_LIST [AST_NODE]}.make
			create in_edges.make (16)
			create out_edges.make (16)
		end

feature {ANY}

	nodes: LIST [AST_NODE]

	in_edges, out_edges: HASH_SET [CFG_EDGE]

feature {ANY}

	add_in_edges (a_edges: HASH_SET [CFG_EDGE])
		require
			a_edges /= Void
		do
			across a_edges as c loop
				(create {CFG_EDGE}.make (c.item.from_block, Current, c.item.label)).do_nothing
			end
		end

	remove_in_edges
		do
			across in_edges.linear_representation as c loop
				c.item.remove
			end
		ensure
			in_edges.is_empty
		end

	add_out_edges (a_edges: HASH_SET [CFG_EDGE])
		require
			a_edges /= Void
		do
			across a_edges as c loop
				(create {CFG_EDGE}.make (Current, c.item.to_block, c.item.label)).do_nothing
			end
		end

	remove_out_edges
		do
			across out_edges.linear_representation as c loop
				c.item.remove
			end
		ensure
			out_edges.is_empty
		end

	get_out_edge (a_to_block: CFG_BASIC_BLOCK): CFG_EDGE
		require
			a_to_block /= Void
		do
			across
				out_edges as c
			until
				Result /= Void
			loop
				if c.item.to_block = a_to_block then
					Result := c.item
				end
			end
		end

	get_out_edge_by_label (a_label: INTEGER_8): CFG_EDGE
		require
			a_label = {CFG_EDGE}.Label_true or a_label = {CFG_EDGE}.Label_false
		do
			across
				out_edges as c
			until
				Result /= Void
			loop
				if c.item.label = a_label then
					Result := c.item
				end
			end
		end

invariant
	nodes /= Void
	in_edges /= Void
	out_edges /= Void

end
