class
	CIL_CHAR_TRANSFORMER

inherit
	TRANSFORMATION_STEP
	AST_DEFAULT_VISITOR
		redefine
			visit_initializer
		end

feature {ANY} -- TRANSFORMATION_STEP

	process_impl: BOOLEAN
		do
			transformer.tree.accept (Current)
			Result := True
		end

	description: STRING
		do
			Result := "Reverting CILs char[] initialization adaptions"
		end

feature {ANY} -- AST_DEFAULT_VISITOR

	visit_initializer (node: AST_INITIALIZER): BOOLEAN
		local
			string: STRING
			all_chars: BOOLEAN
		do
			Result := True

			if
				attached {AST_ARRAY_TYPE} node.type_binding as array_type and then
				attached {AST_BASIC_TYPE} array_type.type as basic_type and then
				basic_type.type = Ast_bt_char
			then
				-- build string from characters
				create string.make (node.elements.count)
				all_chars := True

				across
					node.elements as c
				until
					not all_chars
				loop
					if attached {AST_CAST_EXPRESSION} c.item as cast_expr then
						if attached {AST_CHARACTER_CONSTANT} cast_expr.expression as const then
							string.append (const.value)
						elseif
							attached {AST_DECIMAL_CONSTANT} cast_expr.expression as const and then
							const.value.is_equal ("0")
						then
							string.append_code (const.value.to_natural_8)
						else
							all_chars := False
						end
					else
						all_chars := False
					end
				end

				if all_chars then
					replace_node (node, create {AST_STRING_CONSTANT}.make (string))
					Result := False
				end
			end
		end

end
