class
	SOURCE_VIEWER

inherit
	EV_TITLED_WINDOW
		redefine
			initialize
		end
	EV_KEY_CONSTANTS
		export
			{NONE} all
		undefine
			default_create,
			copy
		end
	VISION2_GC_WORKAROUND

create
	make

feature {NONE}

	make
		do
			default_create
			protect_window_from_gc (Current)
		end

feature {ANY}

	source_code: EV_TEXT

feature {NONE}

	ctrl_down: BOOLEAN

	initialize
		local
			main_container: EV_VERTICAL_BOX
			button_box: EV_HORIZONTAL_BOX
		do
			Precursor {EV_TITLED_WINDOW}

			create main_container
			extend (main_container)

			create source_code
			source_code.key_press_actions.extend (agent key_pressed)
			source_code.key_release_actions.extend (agent key_released)
			main_container.extend (source_code)

			create button_box
			main_container.extend (button_box)
			main_container.disable_item_expand (main_container.i_th (main_container.count))

			button_box.extend (create {EV_HORIZONTAL_BOX}) -- spacer to have the buttons centered
			button_box.extend (create {EV_BUTTON}.make_with_text_and_action ("Save", agent
				local
					dialog: EV_FILE_SAVE_DIALOG
					file: PLAIN_TEXT_FILE
				do
					create dialog.make_with_title ("Save as")
					dialog.show_modal_to_window (Current)
					if not dialog.file_name.is_empty then
						create file.make_open_write (dialog.file_name)
						file.put_string (source_code.text)
						file.flush
						file.close
					end
				end))
			button_box.disable_item_expand (button_box.i_th (button_box.count))
			button_box.extend (create {EV_HORIZONTAL_BOX}) -- spacer to have the buttons centered

			close_request_actions.extend (agent close_request)

			set_title ("SourceViewer")
			set_size (800, 600)
		end

	key_pressed (key: EV_KEY)
		do
			if key.code = Key_ctrl then
				ctrl_down := True
			elseif key.code = Key_a and ctrl_down and source_code.text_length > 0 then
				source_code.select_all
			end
		end

	key_released (key: EV_KEY)
		do
			if key.code = Key_ctrl then
				ctrl_down := False
			end
		end

	close_request
		do
			destroy
		end

end
